/*** The RoboCar Simulator   2012-06-13 ***************/
/*** Copyright (c) 2012 Kosei Demura  All rights reserved. **/
// common.h

#ifndef  _COMMON_H_
#define _COMMON_H_

#define PARTICLE_NUM  500//1000//500  // パーティクル数
#define NUM 4            // Number of wheels
#define STEP_SIZE 0.01   // step size for dWorldStep

#define SENSOR_COV_X 0.3
#define SENSOR_COV_Y 0.3
#define SENSOR_COV_THETA 0.1

// 初期位置と初期姿勢
// 初期位置2011 (-2, 6, 0.11)　[m]
#define START_X  0
#define START_Y  0
#define START_Z  0.11
// 初期姿勢。ロボットの進行方向 [deg]
#define START_DIR 0

#include "ode/ode.h"



typedef struct
{
    dBodyID   body;
    dGeomID  geom;
    dJointID   joint;
    dReal       v;         // 角速度
    dReal       m,r,x,y,z; // 質量，半径，位置(x,y,z)
    dReal       lx,ly,lz;  // sizes[3]
} MyObject;

typedef enum
{
    REAR_RIGHT,   // 後右
    REAR_LEFT,    //  後左
    FRONT_RIGHT, // 前右
    FRONT_LEFT,   // 前左
    //FRONT, // 前
    //LEFT,  // 左
    //REAR,  // 後
    //RIGHT, // 右

} WheelPos;

#endif
