/*** The RoboCar Simulator   2012-05-23 ***************/
/*** Copyright (c) 2012-2014 Kosei Demura  All rights reserved. **/
// main.cpp
// ̃vO͋HƑw@BHwU@m\{bg_p̃V~[^
// FMTRK̃f͋HƑw@BHwU@o@|ĕN쐬D
// X^[gn_(~j̍W (0,0)@[m]
// S[n_iԉ~j̍W (2, 25.5)@[m]
// L[{[h
// P:Ճr[C@Q:{bgڃJr[
// w:Oi, s:i,@aFiv]j d:Eiv]jC//

#include <pthread.h>
#include "main.h"
#include "common.h"

extern void simulation(int width, int height);
extern void *robocarThread(void *);

using namespace simu;

RoboCarClass  *rc     = new RoboCarClass;

//! {bgNX
RoboCarClass::RoboCarClass() // constructor
{
    speed = 0;
    steer  = 0;
    motor_current = 1000.0; // [mA]
    battery_level = 7.2;  // [v]
    servo_present_position = 0; // []
    servo_present_current  = 1000.0;  // [mA]
    servo_present_temperature = 60;  // []
    servo_present_volts = 7200; // [mv]
    sensor.gyro   = 0;
    sensor.acc_x = 0;
    sensor.acc_y = 0;
    sensor.acc_z = 0;
    sensor.enc_0 = 0;
    sensor.enc_1 = 0;
    sensor.enc_2 = 0;
    sensor.enc_3 = 0;
    sensor.enc_4 = 0;
    for (int i=0; i<8; i++)
    {
         obstacle[i] = 0;
    }
    particle = new PARTICLE[PARTICLE_NUM];

    for (int i=0; i< PARTICLE_NUM; i++)
    {
         particle[i].pos[0] = 0;
         particle[i].pos[1] = 0;
         particle[i].pos[2] = 0;
    }
}

RoboCarClass::~RoboCarClass() // constructor
{

}


/*** C֐ ***/
int main(int argc, char *argv[])
{
    pthread_t thread;

    //  {J[Xbh̐
    pthread_create(&thread, NULL, robocarThread, (void *) NULL);

    simulation(WINDOW_WIDTH,WINDOW_HEIGHT);

    pthread_join(thread, NULL);

    return 0;
}
