/*** The RoboCar Simulator   2012-06-27 ***************/
/*** Copyright (c) 2012-2014 Kosei Demura  All rights reserved. **/

// main.h
#ifndef  _MAIN_H_
#define _MAIN_H_

#define WINDOW_WIDTH   800
#define WINDOW_HEIGHT 800

#define WELCOME_TEXT  "Welcome to the RoboCar Simulator Version 0.6 \nAuthor: Kosei Demura 2014-05-19\n"


namespace simu
{

/* ZT\(robocar̍\̂Ɠ)  */
struct SENSOR_VALUE
{
    float gyro;     /*** WCZT [deg/sec].    */
    float acc_x;   /*** xZT(X) [G].        */
    float acc_y;   /*** xZT(Y) [G].        */
    float acc_z;   /*** xZT(Z) [G].        */
    float enc_0;  /*** [^ GR[_ [cycle/sec].*/
    float enc_1;  /*** Wheel GR[_1 [mm/sec]. */
    float enc_2;  /*** Wheel GR[_2 [mm/sec]. */
    float enc_3;  /*** Wheel GR[_3 [mm/sec]. */
    float enc_4;  /*** Wheel GR[_4 [mm/sec]. */
};

struct PARTICLE
{
    float pos[3];     /*** ʒu [m] ***/
    float heading;   /*** pijH) [ ]***/
    float w;           /*** d ***/
};


class RoboCarClass
{
private:

public:
    int speed;       // x[mm]
    float steer;  // ǂ̊px[]
    float motor_current;
    float battery_level;
    float servo_present_position;
	float servo_present_current;
	float servo_present_temperature;
	float servo_present_volts;
	unsigned short obstacle[8];
	SENSOR_VALUE sensor;
	PARTICLE         *particle;

    RoboCarClass();
    ~RoboCarClass();
};

}


#endif
